

var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var extensionRegistry = Components.classes["@mozilla.org/extensions/manager;1"].getService();
if (extensionRegistry)
  extensionRegistry = extensionRegistry.QueryInterface(Components.interfaces.nsIExtensionManager);
var item = extensionRegistry.getItemForID('snapshots@snap.com');
var version = item.version;

try {
  var baseFireshotHREF = prefManager.getCharPref("extensions.fireshots.baseFireshotHREF");
} catch(e) {
  var baseFireshotHREF = "http://shots.snap.com/";
}
try {
  var baseWebHREF = prefManager.getCharPref("extensions.fireshots.baseWebHREF");
} catch(e) {
  var baseWebHREF = "http://www.snap.com/";
}

if(!prefManager.getCharPref("extensions.fireshots.key")){
  var gDirServiceProp = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
  var gProfileDir = gDirServiceProp.get("ProfD", Components.interfaces.nsIFile);

  var req = new XMLHttpRequest();
  req.open('POST', baseWebHREF+'/about/keygen.php', true);
  req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');

  var post_string = "profiledir=" + gProfileDir.path + "&md5=" + hex_md5("ffclient" + gProfileDir.path);
  //alert(post_string);
  req.send(post_string);
  req.onreadystatechange = function (aEvt) {
    if (req.readyState == 4) {
       if(req.status == 200 && req.responseText.match(/^\w{32}$/)){
        //alert(req.responseText);
        //alert("response was a valid key: " + req.responseText);
        prefManager.setCharPref("extensions.fireshots.key", req.responseText);
       }else{
          //alert("response was an invalid key: " + req.responseText);
       }
    }
  };
}



var fireshotsSites, fireshotsBlacklistedSites;
loadSiteArray();
function loadSiteArray() {
  var req = new XMLHttpRequest();
  req.open('GET', baseFireshotHREF + '/client/sites.js', false);
  req.setRequestHeader('Content-Type', 'application/x-javascript');
  req.send("");
  eval(req.responseText);
//  req.onreadystatechange = function (aEvt) {
//    if (req.readyState == 4) {
//       if(req.status == 200){
//        eval(req.responseText);
//       }else{
//          //alert("response was an invalid key: " + req.responseText);
//       }
//    }
//  };
  
}


function fireshotsStatusToggle(){
  var fireshotsEnabled = prefManager.getCharPref("extensions.fireshots.enabled");
  //alert(fireshotsEnabled);
  if(fireshotsEnabled == "1"){
	//call new confirmation menu
	fireshotsSetEnabled(0, "icon");
  }else{
	fireshotsSetEnabled(1, "icon");
  }

}

function fireshotsSetEnabled(newSetting, actionMethod){
  newSetting = "" + newSetting;
  var currentSetting = prefManager.getCharPref("extensions.fireshots.enabled");
  if(currentSetting != newSetting){
	//alert("setting has changed!");
	prefManager.setCharPref("extensions.fireshots.enabled", newSetting);
	


    if(newSetting =="1"){
      prefManager.setCharPref("extensions.fireshots.activate_on_startup", "0");
	  prefManager.setCharPref("extensions.fireshots.activate_on_date", "0");
	  logActionEvent("enable", actionMethod);
    }else{
	  logActionEvent("disable", actionMethod);	
    }
  }


}

function updateStatusIcon(){
  var fireshotsEnabled = prefManager.getCharPref("extensions.fireshots.enabled");
  if(fireshotsEnabled == "0"){
    document.getElementById('fireshots-status-image').src = "chrome://fireshots/content/images/star_off.png";
    document.getElementById('fireshots-status-image').tooltipText = "Snap Shots disabled";
  }else{
    document.getElementById('fireshots-status-image').src = "chrome://fireshots/content/images/star_on.png";
    document.getElementById('fireshots-status-image').tooltipText = "Snap Shots enabled";
  }
}


function logActionEvent(action, actionMethod){

  var req = new XMLHttpRequest();
  req.open('POST', baseFireshotHREF + '/client/action_event', true);
  req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');

  var post_string = "client=FF&action=" + encodeURIComponent(action) + "&method=" + encodeURIComponent(actionMethod) + "&key=" + prefManager.getCharPref("extensions.fireshots.key");
  //alert(post_string);
  req.send(post_string);
//alert("sent_string");
req.onreadystatechange = function (aEvt) {
	//alert("got response!");
  };

}



var scriptInjector={

deactivationPrompt: function(methodName){
	current = prefManager.getCharPref("extensions.fireshots.enabled");
	
	prefManager.setCharPref("extensions.fireshots.deactivationMethod", methodName);
	window.openDialog("chrome://fireshots/content/deactivate.xul", "fireshots-deactivate-window", "resizable,centerscreen,modal");
	
	updateStatusIcon();	
	return true;
},

iconClick: function(methodName){
	current = prefManager.getCharPref("extensions.fireshots.enabled");
	if(current =="0"){
		fireshotsSetEnabled("1", 'icon');
	}else{
		scriptInjector.deactivationPrompt('icon');
	}
	updateStatusIcon();	
	
},

prefMenuClicked: function() {
  window.openDialog("chrome://fireshots/content/preferences.xul", "fireshots-pref-window", "resizable,centerscreen,modal");
  updateStatusIcon();
},

aboutScreenClicked: function() {
  window.openDialog("chrome://fireshots/content/about.xul", "fireshots-about-window", "resizable,centerscreen,modal");

},

getUrlContents: function(aUrl){
	var	ioService=Components.classes["@mozilla.org/network/io-service;1"]
		.getService(Components.interfaces.nsIIOService);
	var	scriptableStream=Components
		.classes["@mozilla.org/scriptableinputstream;1"]
		.getService(Components.interfaces.nsIScriptableInputStream);

	var	channel=ioService.newChannel(aUrl, null, null);
	var	input=channel.open();
	scriptableStream.init(input);
	var	str = "";
	while(true)
	{
  	var buf = scriptableStream.read(input.available());
  	if (buf.length == 0)
  	  break;
  	str += buf;
  }
	scriptableStream.close();
	input.close();

	return str;
},

isShotsPage: function(url) {

	var scheme=Components.classes["@mozilla.org/network/io-service;1"]
		.getService(Components.interfaces.nsIIOService)
		.extractScheme(url);
	return (
		(scheme == "http")
	);


},

contentLoad: function(e) {
/*
  try {
    var stored_version = prefManager.getCharPref("extensions.fireshots.version");
  } catch(e) {
    var stored_version = "0";
  }
*/
  var seen_welcome_page = prefManager.getCharPref("extensions.fireshots.seen_welcome_page");
  //alert(seen_welcome_page);

  if(prefManager.getCharPref("extensions.fireshots.key") != "" && seen_welcome_page == "0"){
    var install_url = baseWebHREF+"/about/shotsdownload_thankyou.php?type=install&campaign=addon_ff_"+version + "&build=" + version +"&key="+prefManager.getCharPref("extensions.fireshots.key");

    var source = prefManager.getCharPref("extensions.fireshots.publisher_id");
    if(source != "")
      install_url += "&source=" + source;

    if(source == "") gBrowser.selectedTab = gBrowser.addTab(install_url);
    prefManager.setCharPref("extensions.fireshots.seen_welcome_page", "1");
    prefManager.setCharPref("extensions.fireshots.version", version);
  }
  updateStatusIcon();

  var fireshotsEnabled = prefManager.getCharPref("extensions.fireshots.enabled");
  var fireshotsActivateAfter = prefManager.getCharPref("extensions.fireshots.activate_on_date");

  //check for disable delay and see if we should enable
  if(fireshotsEnabled =="0" && fireshotsActivateAfter >0){
    var time = new Date();
    var currentTime = time.getTime();
    if(currentTime > fireshotsActivateAfter){
	  prefManager.setCharPref("extensions.fireshots.enabled", "1");
	  prefManager.setCharPref("extensions.fireshots.activate_on_date", "0");
	  fireshotsEnabled = "1";
	  updateStatusIcon();
    }
  }

  //check to see if the user just enabled the add-on after disabling
  var wasDisabled = prefManager.getCharPref("extensions.fireshots.addon_disabled");
  if(wasDisabled == "1"){
    prefManager.setCharPref("extensions.fireshots.addon_disabled", "0");
    logActionEvent("enable", "browser");
  }



  if(fireshotsEnabled == "0"){

  }else{
  	var unsafeWin=e.target.defaultView;
  	if (unsafeWin.wrappedJSObject) unsafeWin=unsafeWin.wrappedJSObject;

  	var unsafeLoc=new XPCNativeWrapper(unsafeWin, "location").location;
  	var href=new XPCNativeWrapper(unsafeLoc, "href").href;

  	if (
  		scriptInjector.isShotsPage(href)
      && true
  		&& true
  	) {
  	  loadSiteArray();
  	  
  		var script=scriptInjector.getUrlContents(
  			baseFireshotHREF + '/client/shotssetup.js'
  		);
  		scriptInjector.injectScript(script, href, unsafeWin);
  	}
  }
},

injectScript: function(script, url, unsafeContentWin) {
	var sandbox, script, logger, storage, xmlhttpRequester;
	var safeWin=new XPCNativeWrapper(unsafeContentWin);

	sandbox=new Components.utils.Sandbox(safeWin);
	sandbox.window=safeWin;
	sandbox.document=sandbox.window.document;
	sandbox.unsafeWindow=unsafeContentWin;

	// patch missing properties on xpcnw
	sandbox.XPathResult=Components.interfaces.nsIDOMXPathResult;
	sandbox.__proto__=sandbox.window;

  sandbox.SNAP_COM_CLIENT = new Object;
  sandbox.SNAP_COM_CLIENT.fireshotsBlacklistedSites = fireshotsBlacklistedSites;
  sandbox.SNAP_COM_CLIENT.fireshotsSites = fireshotsSites;
//  sandbox.url = url;
  sandbox.SNAP_COM_CLIENT.baseShotHREF = baseFireshotHREF;
  
  sandbox.SNAP_COM_CLIENT.disabledSites = prefManager.getCharPref("extensions.fireshots.disabledSites");
  sandbox.SNAP_COM_CLIENT.si = prefManager.getCharPref("extensions.fireshots.si");;
  sandbox.SNAP_COM_CLIENT.key = prefManager.getCharPref("extensions.fireshots.key");
  sandbox.SNAP_COM_CLIENT.th = prefManager.getCharPref("extensions.fireshots.th");
  sandbox.SNAP_COM_CLIENT.sb = prefManager.getCharPref("extensions.fireshots.sb");
  sandbox.SNAP_COM_CLIENT.link_icon = prefManager.getCharPref("extensions.fireshots.link_icon");
  sandbox.SNAP_COM_CLIENT.shots_trigger = prefManager.getCharPref("extensions.fireshots.shots_trigger");
  sandbox.SNAP_COM_CLIENT.size = prefManager.getCharPref("extensions.fireshots.size");
  sandbox.SNAP_COM_CLIENT.lang = prefManager.getCharPref("extensions.fireshots.lang");
  sandbox.SNAP_COM_CLIENT.source = prefManager.getCharPref("extensions.fireshots.publisher_id");
  sandbox.SNAP_COM_CLIENT.campaign = "addon_ff_" + version;

//  var params = {};
//  var blacklisted = false;
//  for (var x=0; x < fireshotsBlacklistedSites.length; x++) {
//    if(url.match(fireshotsBlacklistedSites[x])){
//      //alert("blacklisted!");
//      blacklisted = true;
//      break;
//    }
//  }
//
//  if(!blacklisted){
//    var site_name;
//    var frameOverride = false;
//    var metaTags = sandbox.window.document.getElementsByTagName('meta');
//    var metaTagLength = metaTags.length;
//    for(var key in fireshotsSites){
//      if(url.match(fireshotsSites[key].regex)){
//        site_name = key;
//        break;
//      }
//      fireshotsMeta = fireshotsSites[key].meta;
//      if (typeof site_name == "undefined" && fireshotsMeta) {
//        for (var i = 0; i < fireshotsMeta.length; i++) {
//          var desired_meta_object = fireshotsMeta[i];
//          
//          for (var j = 0; j < metaTagLength; j++) {
//            found = true;
//            var meta_object = metaTags[j];
//            for (var meta_key in desired_meta_object) {
//              if (meta_object[meta_key] != desired_meta_object[meta_key]) {
//                found = false;
//              }
//            }
//            if (found) site_name = key;
//          }
//        }
//      }
//    }
//    var disabled = false;
//    params['ro'] = "0";
//
//    if(site_name){
//      sandbox.site_name = site_name;
//
//      var disabledSites = prefManager.getCharPref("extensions.fireshots.disabledSites").split(",");
//      for(var i in disabledSites){
//        if(key == disabledSites[i]){
//          disabled = true
//          break;
//        }
//      }
//    }else{
//      sandbox.site_name = "";
//      params['ro'] = "1";
//    }
//  }
//
//  if(disabled || blacklisted){
//    //alert("user has disabled " + site_name);
//  }else{
//    params['ap'] = "1";
//    params['tc'] = "0";
//    params['tp'] = "1";
//    params['hdd'] = "1500";
//
//    params['si'] = prefManager.getCharPref("extensions.fireshots.si");
//    params['key'] = prefManager.getCharPref("extensions.fireshots.key");
//    params['th'] = prefManager.getCharPref("extensions.fireshots.th");
//    params['sb'] = prefManager.getCharPref("extensions.fireshots.sb");
//    params['link_icon'] = prefManager.getCharPref("extensions.fireshots.link_icon");
//    params['shots_trigger'] = prefManager.getCharPref("extensions.fireshots.shots_trigger");
//    params['size'] = prefManager.getCharPref("extensions.fireshots.size");
//    params['lang'] = prefManager.getCharPref("extensions.fireshots.lang");
//
//    var source = prefManager.getCharPref("extensions.fireshots.publisher_id");
//    if(source != "")
//      params['domain'] = source;
//
//    params['campaign'] = "addon_ff_"+version;
//
//    if(site_name){
//      params['si'] = "1";
//      params['tc'] = "15";
//      params['sb'] = "0";
//    }
//
//    //override params with what we've definite in sites.js
//    if(site_name && fireshotsSites[site_name].params) {
//      for(var param_name in fireshotsSites[site_name].params){
//        params[param_name] = fireshotsSites[site_name].params[param_name];
//      }
//    }
//
//    if(params['framed']){
//      frameOverride = true;
//    }
//    sandbox.frameOverride = frameOverride;
//
//    //create an argument string
//    param_pairs = new Array();
//    for(var param_name in params){
//      param_pairs.push(param_name + "=" + params[param_name]);
//    }
//    sandbox.params = params;
//    //sandbox.shots_url = 'http://luca.pas.lab:43080/snap_shots.js?' + param_pairs.join("&");
//    sandbox.shots_url = baseFireshotHREF + '/snap_shots.js?' + param_pairs.join("&");

    //alert(sandbox.shots_url);

  	try {
  		this.evalInSandbox(
  			"(function(){"+script+"})()",
  			url,
  			sandbox);
  	} catch (e) {
      try {
        var debug = prefManager.getCharPref("extensions.fireshots.debug");
        if (debug == "1") {
        		var e2=new Error(typeof e=="string" ? e : e.message);
        		e2.fileName=script.filename;
        		e2.lineNumber=0;
        		//GM_logError(e2);
        		alert(e2);
        }
      } catch(e) {

      }
  	}
//  }

},

evalInSandbox: function(code, codebase, sandbox) {
	if (Components.utils && Components.utils.Sandbox) {
		// DP beta+
		Components.utils.evalInSandbox(code, sandbox);
	} else if (Components.utils && Components.utils.evalInSandbox) {
		// DP alphas
		Components.utils.evalInSandbox(code, codebase, sandbox);
	} else if (Sandbox) {
		// 1.0.x
		evalInSandbox(code, sandbox, codebase);
	} else {
		throw new Error("Could not create sandbox.");
	}
},

onLoad: function() {

  	var	appcontent=window.document.getElementById("appcontent");
  	if (appcontent && !appcontent.injectorized) {
      updateStatusIcon();
  		appcontent.injectorized=true;
  		appcontent.addEventListener("DOMContentLoaded", scriptInjector.contentLoad, false);
  	}
},

onUnLoad: function() {
	//remove now unnecessary listeners
	window.removeEventListener('load', scriptInjector.onLoad, false);
	window.removeEventListener('unload', scriptInjector.onUnLoad, false);

  // remove uninstall listener
  gFireShotsUninstallObserver.removeObserver();

  if(window.document.getElementById("appcontent")){
	 window.document.getElementById("appcontent").removeEventListener("DOMContentLoaded", scriptInjector.contentLoad, false);
  }
},
};

//uninstall code
function fireShotsUninstallObserver() {
  this._observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
  this._observerService.addObserver(this, "em-action-requested", false);
  this._guid = 'snapshots@snap.com';
  this._uninstallURL = baseWebHREF+"/about/shotsuninstall.php?campaign=addon_ff_"+version+"&build="+version+"&key="+prefManager.getCharPref("extensions.fireshots.key");

  var source = prefManager.getCharPref("extensions.fireshots.publisher_id");
  if(source != "")
    this._uninstallURL += "&source=" + source;

  prefManager.setCharPref("extensions.fireshots.uninstall_screen_shown", "false");
}

fireShotsUninstallObserver.prototype = {
  observe: function(subject, topic, data) {
    if ((topic == "em-action-requested") && (data == "item-uninstalled")) {
	  prefManager.setCharPref("extensions.fireshots.seen_welcome_page", "0");
      var bUninstallScreenShown;
      bUninstallScreenShown = prefManager.getCharPref("extensions.fireshots.uninstall_screen_shown");
      if (bUninstallScreenShown == 'true') return;
      prefManager.setCharPref("extensions.fireshots.uninstall_screen_shown", "true");
      var updateItem = subject.QueryInterface(Components.interfaces.nsIUpdateItem);
      if (updateItem.id == this._guid) {
		prefManager.setCharPref("extensions.fireshots.seen_welcome_page", "1");
        if (window.getBrowser) {
          var newTab = window.getBrowser().addTab(this._uninstallURL);
          window.getBrowser().selectedTab = newTab;
        } else {
          openDialog("chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", this._uninstallURL);
        }
      }
    }
  },

  removeObserver : function() {
    this._observerService.removeObserver(this, "em-action-requested");
  }
}

// Start uninstall observer
var gFireShotsUninstallObserver = new fireShotsUninstallObserver();







//disable code
function fireShotsDisableObserver() {
  this._observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
  this._observerService.addObserver(this, "em-action-requested", false);
  this._guid = 'snapshots@snap.com';
}

fireShotsDisableObserver.prototype = {
  observe: function(subject, topic, data) {
    if ((topic == "em-action-requested") && (data == "item-disabled")) {
 	  var updateItem = subject.QueryInterface(Components.interfaces.nsIUpdateItem);
      if (updateItem.id == this._guid) {
	    prefManager.setCharPref("extensions.fireshots.addon_disabled", "1");
        logActionEvent("disable", "browser");
	  }
    }
  },

  removeObserver : function() {
    this._observerService.removeObserver(this, "em-action-requested");
  }
}

// Start uninstall observer
var gFireShotsDisableObserver = new fireShotsDisableObserver();


//ridiculous bad server logging.  firefox wants to make this really difficult for some reason so
//here is our really flawed approach.
function valueIsInArray(value, array){
  var array_length = array.length;
  for (var i=0; i < array_length; i++) {
    if(array[i] == value) return true;
  }
  return false;
}

var unknownHosts = new Array();
var goodHosts = new Array();

setInterval(
  function () {
    var unknown = unknownHosts;
    var good = goodHosts;
    var bad = new Array();
	
    //reset the collector arrays
    unknownHosts = new Array();
    goodHosts = new Array();

    var unknown_length = unknown.length;

    for (var i=0; i < unknown_length; i++) {
      if(!valueIsInArray(unknown[i], bad)){
        if(!valueIsInArray(unknown[i], good)){
          //alert(unknown[i] + " is a bad domain name");
            bad.push(unknown[i]);
        }			
      }
    }

	//post the bad urls
	if(bad.length){
		//alert("preparing to post " + bad.length + " urls");
		var params = new Array();
		for (var i=0; i < bad.length; i++) {
			params.push("url" + i + "=" + encodeURIComponent(bad[i]));
		}

		var req = new XMLHttpRequest();
		req.open('POST', baseFireshotHREF + '/client/bad_url', true);
		req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
		req.send(params.join("&"));
		//alert("posted " + bad.length + " urls");
	}
  }, 120000);

function fireShotsRequestObserver() {
  this._observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
  this._observerService.addObserver(this, "http-on-modify-request", false);
  this._observerService.addObserver(this, "http-on-examine-response", false);
}

fireShotsRequestObserver.prototype = {
  observe: function(subject, topic, data) {
    if(topic == "http-on-modify-request"){
      var host = subject.getRequestHeader("Host");
      unknownHosts.push(host);
    }
    if(topic == "http-on-examine-response"){
      if(subject.responseStatus){
        var host = subject.getRequestHeader("Host");
        goodHosts.push(host);
      }		
    }
  },

  removeObserver : function() {
    this._observerService.removeObserver(this, "http-on-modify-request");
	this._observerService.removeObserver(this, "http-on-examine-response");
  }
}

//start request observer
var gFireShotsRequestObserver = new fireShotsRequestObserver();



window.addEventListener('load', scriptInjector.onLoad, false);
window.addEventListener('unload', scriptInjector.onUnLoad, false);
